/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*-
 *
 * LASER
 * Copyright (C) 2006 Benjamin Canou <bookeldor@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __LASER_BOARD_H
#define __LASER_BOARD_H

#	include "config.h"

#include <gtk/gtk.h>

#include "laser-common.h"
#include "laser-config.h"

typedef enum {
	EDIT_MODE,
	SET_MODE,
	PLAY_MODE,
	VIEW_MODE
} board_mode;

typedef struct board board_t;

board_t* laser_board_attach  (GtkWidget *widget, board_mode mode,
															LaserConfig* config, 
															void (*update_score_cb) (gpointer, gint, gint, gint, gboolean, gboolean),
															gboolean *modified,
															gpointer update_score_data);

void laser_board_set_level   (board_t* board, level *level);
void laser_board_set_actions (board_t *board, gint actions);
void laser_board_paint       (board_t *board);
void laser_board_set_mode    (board_t *board, board_mode mode, guint16 type, guint8 colour);
void laser_board_reset       (board_t *board);
void laser_board_undo        (board_t *board);
void laser_board_redo        (board_t *board);
void laser_board_resize      (board_t *board, guint grow_or_shrink, guint direction);
gchar* laser_board_get_cheat (board_t *board);
void   laser_board_set_cheat (board_t *board, gchar* code);

#endif /*__LASER_BOARD_H*/
